//+------------------------------------------------------------------+
//|												 Copyright  2010, JACreative |
//|																 KGForexWorld.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, KGForexWorld.com"
#property link      "http://www.kgforexworld.com"

#property indicator_chart_window
#property indicator_buffers 0

extern	string	Readme1	= "#--- Periode Input",
						Readme2	= "5M 15M 30M 1H 4H 8H 16H",
						Readme3	= "1D 1W 2W 1MH 4MH 6MH 1Y",
						Periode_01	= "8H",
						Periode_02	= "1D",
						Periode_03	= "1W",
						Periode_04	= "1MH",
						Periode_05	= "4MH",
						PriceMode	= "HL";
extern	int		SHOW_BAR		= 15,
						Y				= 10,
						Corner      = 1;
extern	bool		ALARM			= false;



int 		CNT,TMP_Y,X=40,TMP_X,TOTAL_BAR,TChar,LIST[10];

double	LSMA[5][30],BSB[5][30];

string   Periode[5],Status_LSMA[5][30],
			PERUBAHAN_KONDISI[2],LabelName,KONDISI[5][30],KONDISI_TICK[5][2];

int		Warna[5],Per[5];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
	int i;

	if(SHOW_BAR > 30)
		SHOW_BAR = 30;

	TChar = StringLen(PriceMode);
	for(i=0;i<TChar;i++){
		LIST[i] = StringGetChar(PriceMode,i);
	}

	TMP_X = X;
	TMP_Y = Y;

	Periode[0] = Periode_01;
	Periode[1] = Periode_02;
	Periode[2] = Periode_03;
	Periode[3] = Periode_04;
	Periode[4] = Periode_05;

	for(i=0;i<5;i++){
		Set_Periode(Periode[i],i);
	}

	LabelName = "PKPH";
   return(0);
}


//+-------------------------------------------------------------------+
//| deinit													                      |
//+-------------------------------------------------------------------+
int deinit(){
	int i,j;

	i=0;
	while(ObjectDelete(LabelName+i)){
		j=0;
		while(ObjectDelete(LabelName+i+j)){
			j++;
		}
		i++;
	}
   return(0);
}



//+------------------------------------------------------------------+
//| start															               |
//+------------------------------------------------------------------+
void start(){
	int SARROW,i,j;

	if(TOTAL_BAR != Bars){
		TOTAL_BAR = Bars;
		SARROW = SHOW_BAR;
	}
	else
		SARROW = 2;

	PERUBAHAN_KONDISI[1] = PERUBAHAN_KONDISI[0];
	PERUBAHAN_KONDISI[0]	= "";

	for(i=0;i<5;i++){

		//-- LSMA & BSB
		for(j=0;j<SARROW;j++){
			LSMA[i][j]	= Search_LSMA(i,j);
			BSB[i][j]	= (iHigh(NULL,0,iHighest(NULL, 0, MODE_HIGH, Per[i], j))+iLow(NULL,0,iLowest(NULL, 0, MODE_LOW, Per[i], j)))/2;
		}

		for(j=0;j<SARROW;j++){
			if((LSMA[i][j]-LSMA[i][j+1]) > 0)
				Status_LSMA[i][j]  = "UP";
			else
	 	  		Status_LSMA[i][j]  = "DOWN";

			KONDISI[i][j] = Kondisi(j,LSMA[i][j],Status_LSMA[i][j],BSB[i][j]);
		}

		KONDISI_TICK[i][1]	= KONDISI_TICK[i][0];
		KONDISI_TICK[i][0]	= KONDISI[i][0];
		PERUBAHAN_KONDISI[0] = PERUBAHAN_KONDISI[0]+KONDISI_TICK[i][0];
	}// END FOR


	Y		= TMP_Y;
	CNT	= 0;
	if(PERUBAHAN_KONDISI[0] != PERUBAHAN_KONDISI[1]){
		for(i=0;i<5;i++){
			Print_Legend(Periode[i], 8, Y, Warna[i]);
			Y +=10;
			Print_Legend(KONDISI[i][0], 8, Y, Warna[i]);
			Y +=21;

			// ALARM
			if( 	((GlobalVariableCheck("Alarm") && (GlobalVariableGet("Alarm") == 1)) || (ALARM)) &&
					(KONDISI_TICK[i][0] != KONDISI_TICK[i][1]) && (StringLen(KONDISI_TICK[i][1])>5)){
				PlaySound("Speech On.wav");
				Print(" 'PKPH "+ Periode[i] + "' : "+ KONDISI_TICK[i][1] + "=>" + KONDISI_TICK[i][0]);
			}
		}

	}


	Y=TMP_Y+2;
	for(i=0;i<5;i++){
 		X=TMP_X;
		for(j=0;j<SARROW;j++){
			
			if(ObjectFind(LabelName+i+j) == -1){
				ObjectCreate(LabelName+i+j, OBJ_LABEL, 0, 0, 0);
				ObjectSetText(LabelName+i+j, "n", 8, "Wingdings", SET_COLOR(i,j));
				ObjectSet(LabelName+i+j, OBJPROP_XDISTANCE, X);
				X+=8;
				ObjectSet(LabelName+i+j, OBJPROP_YDISTANCE, Y);
				ObjectSet(LabelName+i+j, OBJPROP_CORNER, Corner);
			}
			ObjectSet(LabelName+i+j, OBJPROP_COLOR, SET_COLOR(i,j));
		}
		Y +=30;
	}
}


color	SET_COLOR(int SC_I,int SC_J){

	if(StringFind(KONDISI[SC_I][SC_J], "Trending Up", 0) >= 0)
		return(Blue);
	else if(StringFind(KONDISI[SC_I][SC_J], "Trending Down", 0) >= 0)
		return(Red);
	else if(StringFind(KONDISI[SC_I][SC_J], "Sideway Continuation", 0) >= 0)
		return(Gray);
	else if(StringFind(KONDISI[SC_I][SC_J], "Sideway Retrace", 0) >= 0)
		return(White);
   return(Black);
}

void Set_Periode(string SP_Periode, int i){

	if(SP_Periode == "1Y")			{ Warna[i]	= BlueViolet;		Per[i] = MathCeil(345600/Period()); }
	else if(SP_Periode == "6MH")	{ Warna[i]	= YellowGreen;		Per[i] = MathCeil(172800/Period()); }
	else if(SP_Periode == "4MH")	{ Warna[i]	= SandyBrown;  	Per[i] = MathCeil(115200/Period()); }
	else if(SP_Periode == "1MH")	{ Warna[i]	= Aqua;				Per[i] = MathCeil(28800/Period()); }
	else if(SP_Periode == "2W")	{ Warna[i]	= OrangeRed;		Per[i] = MathCeil(14400/Period()); }
	else if(SP_Periode == "1W")	{ Warna[i]	= Magenta;			Per[i] = MathCeil(7200/Period()); }
	else if(SP_Periode == "1D")	{ Warna[i]	= Lime;				Per[i] = MathCeil(1440/Period()); }
	else if(SP_Periode == "16H")	{ Warna[i]	= Coral;				Per[i] = MathCeil(960/Period()); }
	else if(SP_Periode == "8H")	{ Warna[i]	= Yellow;			Per[i] = MathCeil(480/Period()); }
	else if(SP_Periode == "4H")	{ Warna[i]	= RoyalBlue;		Per[i] = MathCeil(240/Period()); }
	else if(SP_Periode == "1H")	{ Warna[i]	= Red;				Per[i] = MathCeil(60/Period()); }
	else if(SP_Periode == "30M")	{ Warna[i]	= DarkViolet;		Per[i] = MathCeil(30/Period()); }
	else if(SP_Periode == "15M")	{ Warna[i]	= White;				Per[i] = MathCeil(15/Period()); }
	else if(SP_Periode == "5M")	{ Warna[i]	= Peru;				Per[i] = MathCeil(5/Period()); }
	else if(SP_Periode == "1M")	{ Warna[i]	= DarkSlateGray;	Per[i] = MathCeil(1/Period()); }
	else { Warna[i] = NULL;	Per[i] = 0; }

}

string Kondisi(int Shift,double tLSMA, string tStatus_LSMA, double tBSB){

	double TMP_ARY[2];
	TMP_ARY[0]  = tLSMA;
	TMP_ARY[1]  = tBSB;
	
	// LSMA DIATAS
	if(tLSMA > tBSB){
	   if(tStatus_LSMA == "UP"){
			if((TMP_ARY[ArrayMaximum(TMP_ARY,WHOLE_ARRAY,0)] > Close[Shift]) && (TMP_ARY[ArrayMinimum(TMP_ARY,WHOLE_ARRAY,0)] < Close[Shift])){
				return("Sideway Continuation Up");
			}
			else if(tLSMA <= Close[Shift]){
				return("Trending Up - Strong");
			}
			else if(tBSB >= Close[Shift]){
				return("Trending Down - Very Weak");
			}
		}
		else if(tStatus_LSMA == "DOWN"){
			if((TMP_ARY[ArrayMaximum(TMP_ARY,WHOLE_ARRAY,0)] > Close[Shift]) && (TMP_ARY[ArrayMinimum(TMP_ARY,WHOLE_ARRAY,0)] < Close[Shift])){
				return("Sideway Retrace Down");
			}
			else if(tLSMA <= Close[Shift]){
				return("Trending Up - Weak");
			}
			else if(tBSB >= Close[Shift]){
				return("Trending Down - Medium");
			}
		}
	}

	// LSMA DIBAWAH
	else if(tLSMA < tBSB){
	   if(tStatus_LSMA == "UP"){
			if((TMP_ARY[ArrayMaximum(TMP_ARY,WHOLE_ARRAY,0)] > Close[Shift]) && (TMP_ARY[ArrayMinimum(TMP_ARY,WHOLE_ARRAY,0)] < Close[Shift])){
				return("Sideway Retrace Up");
			}
			else if(tBSB <= Close[Shift]){
				return("Trending Up - Medium");
			}
			else if(tLSMA > Close[Shift]){
				return("Trending Down - Weak");
			}
		}
		else if(tStatus_LSMA == "DOWN"){
			if((TMP_ARY[ArrayMaximum(TMP_ARY,WHOLE_ARRAY,0)] > Close[Shift]) && (TMP_ARY[ArrayMinimum(TMP_ARY,WHOLE_ARRAY,0)] < Close[Shift])){
				return("Sideway Continuation Down");
			}
			else  if(tBSB <= Close[Shift]){
				return("Trending Up  Very weak");
			}
			else if(tLSMA >= Close[Shift]){
				return("Trending Down - Strong");
			}
		}
	}
   return("");
}



double Search_LSMA(int NO_ARY,int shift){

	double A,B,PosisiHarga,tX,tY,XY,X2,TMP_BAGI;
	int j;

	tX = 0;
	tY = 0;
	XY = 0;
	X2 = 0;
	TMP_BAGI = 0;

	for(j=1; j<=Per[NO_ARY]; j++){
		PosisiHarga = POSISI_HARGA(shift + j - 1);

		tX	+= j;
		tY	+= PosisiHarga;
		XY	+= j*PosisiHarga;
		X2	+= j*j;
	}

	TMP_BAGI	= (Per[NO_ARY]*X2)-(tX*tX);
	if(TMP_BAGI == 0)
		TMP_BAGI = 0.000001;

	B = ((Per[NO_ARY]*XY)-(tX*tY))/TMP_BAGI;
	A = (tY-(B*tX))/Per[NO_ARY];

	return(A+(B*1));
}


double POSISI_HARGA(int Bar){

	int i;
	double POSISI=0;
	//H=104/72 L=76/108 O=79/111	C=67/99

	for(i=0;i<TChar;i++){
		//-- HIGH
		if((LIST[i] == 104) || (LIST[i] == 72)){
			POSISI += High[Bar];
		}
		//-- LOW
		else if((LIST[i] == 76) || (LIST[i] == 108)){
			POSISI += Low[Bar];
		}
		//-- OPEN
		else if((LIST[i] == 79) || (LIST[i] == 111)){
			POSISI += Open[Bar];
		}	
		//-- CLOSE
		else if((LIST[i] == 67) || (LIST[i] == 99)){
			POSISI += Close[Bar];
		}
	}

	return(NormalizeDouble(POSISI/TChar,Digits));
}





void Print_Legend(string txt, int AX, int AY, color Col){

	

	if(ObjectFind(LabelName+CNT) == -1){
		ObjectCreate(LabelName+CNT, OBJ_LABEL, 0, 0, 0);
		ObjectSetText(LabelName+CNT, txt, 8, "Verdana", Col);
		ObjectSet(LabelName+CNT, OBJPROP_CORNER, Corner);
		ObjectSet(LabelName+CNT, OBJPROP_XDISTANCE, AX);
		ObjectSet(LabelName+CNT, OBJPROP_YDISTANCE, AY);
	}
	else
		ObjectSetText(LabelName+CNT, txt ,8, "Verdana", Col);

	CNT++;
}